<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich" xmlns:f="http://java.sun.com/jsf/core"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h2>#{messages['net.ihe.gazelle.patientmanager.PatientCreationForAdmin']}</h2>
        <h:form id="globalForm">
            <gri:panel pid="actorP">
                <f:facet name="header">#{messages['net.ihe.gazelle.patientmanager.SelectTheActorWhichWillOwnThePatient']}</f:facet>
                <div class="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:param name="id" value="actorIn"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.OwningActor']}</ui:define>
                        <h:selectOneMenu value="#{patientCreator.ownerActor}" required="true"
                                         styleClass="form-control" id="actorIn">
                            <s:selectItems value="#{patientCreator.getListOfAvailableActors()}"
                                           var="entry" label="#{entry.keyword} - #{entry.name}"
                                           noSelectionLabel="#{messages['net.ihe.gazelle.pam.PleaseSelect']}"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </div>
            </gri:panel>
            <s:div id="patientDiv">
                <gri:panel pid="ddsPanel" rendered="#{patientCreator.displayDDSPanel}">
                    <f:facet name="header">#{messages['net.ihe.gazelle.patientmanager.GenerateAPatientWithDDS']}</f:facet>
                    <ui:include src="/patient/patientGenerator.xhtml">
                        <ui:param name="patientGeneratorBean" value="#{patientCreator}"/>
                        <ui:param name="displayAllCriteria" value="#{true}"/>
                        <ui:param name="ddsEndpoint"
                                  value="#{patientCreator.ddsWsEndpoint}"/>
                    </ui:include>
                    <s:div id="genIds">
                        <h3>#{messages['net.ihe.gazelle.PatientManager.PatientIdentifiers']}</h3>
                        <s:decorate template="/layout/form/_checkbox.xhtml">
                            <h:selectBooleanCheckbox value="#{patientCreator.useIdsFromDDS}">
                                <a4j:ajax event="change" render="genIds"/>
                            </h:selectBooleanCheckbox>
                            <ui:define name="label">#{messages['gazelle.PAMSimulator.UseIDsFromDDS']}</ui:define>
                        </s:decorate>
                        <s:decorate template="/layout/form/_checkbox.xhtml"
                                    rendered="#{patientCreator.isConnectathonFeatureEnabled()}">
                            <h:selectBooleanCheckbox value="#{patientCreator.generateIdsForConnectathon}">
                                <a4j:ajax event="change" render="genCatIds"/>
                            </h:selectBooleanCheckbox>
                            <ui:define name="label">#{messages['gazelle.PAMSimulator.GenerateIdentifiersForConnectathonAssigningAutho']}</ui:define>
                        </s:decorate>
                        <s:decorate template="/layout/form/_checkbox.xhtml">
                            <h:selectBooleanCheckbox value="#{patientCreator.generateIdsForAuthorities}">
                                <a4j:ajax event="change" render="genIds"/>
                            </h:selectBooleanCheckbox>
                            <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.UsePredefinedAuthorities']}</ui:define>
                        </s:decorate>
                        <div class="row">
                            <div class="col-lg-8">
                                <rich:pickList value="#{patientCreator.selectedAuthorities}" var="aa"
                                               listWidth="350px" sourceCaption="Available assigning authorities"
                                               targetCaption="Selected assigning authorities" orderable="false"
                                               rendered="#{patientCreator.generateIdsForAuthorities}">
                                    <s:selectItems value="#{patientCreator.availableAuthorities}" var="hd"
                                                   label="#{hd.displayWithAmp()}"/>
                                    <g:column>
                                        <h:outputText value="#{aa.displayWithAmp()}"/>
                                    </g:column>
                                </rich:pickList>
                            </div>
                        </div>
                    </s:div>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['gazelle.simulator.pam.GeneratePatient']}"
                                           styleClass="gzl-btn-blue" render="patientDiv"
                                           actionListener="#{patientCreator.generateAndSavePatient()}"/>
                    </f:facet>
                </gri:panel>
                <gri:panel pid="patientEditDiv" rendered="#{not patientCreator.displayDDSPanel}">
                    <f:facet name="header">#{messages['net.ihe.gazelle.patientmanager.PatientEditor']}</f:facet>
                    <ui:include src="/pds/editPatientWithIdManagement.xhtml">
                        <ui:param name="patient" value="#{patientCreator.selectedPatient}"/>
                        <ui:param name="renderHistory" value="false"/>
                        <ui:param name="renderEncounters" value="false"/>
                        <ui:param name="renderZFD" value="false"/>
                        <ui:param name="zfp" value="false"/>
                        <ui:param name="zfs" value="false"/>
                        <ui:param name="renderRelationships" value="true"/>
                        <ui:param name="managedBean" value="#{patientCreator}"/>
                        <ui:param name="renderRelationships" value="#{false}"/>
                    </ui:include>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['gazelle.HL7Common.Save']}"
                                           actionListener="#{patientCreator.savePatient()}"
                                           render="patientDiv"
                                           styleClass="gzl-btn-green"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.patientmanager.SaveAndCreateAnotherPatient']}"
                                           actionListener="#{patientCreator.savePatientAndReset()}"
                                           render="patientDiv"
                                           styleClass="gzl-btn-green"/>
                    </f:facet>
                </gri:panel>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>